#include "CatSummary.h"

bool catSummaryExists( const char* fname )
{
	ifstream catfile(fname);
	bool exist;
	if (! catfile )
	{
		exist = 0;
	} else {

		exist = 1;
		catfile.close();
	}
	return exist;
}

void blankCatSummary( const char* fname )
{

	ofstream catfile(fname);
	if (! catfile)
	{
		errstr << "Received error trying to open file for blank catalogue page." << Sas::fatal("ppssumm:FILECREATION");
	}

	HtmlPage page("catpage");

	std::string htitle("Observation " + PpssummCommon::obsid_ + " ACDS Cross-Correlation Page");
	errstr << "Generating " << htitle << Sas::message(Msg::App, Msg::Verbose);
	const HtmlTag hr("hr");

	page.title(htitle);
	page.linkbar("catpage");
	page.body_ << hr;
	page.sub_title(PpssummCommon::sub_title_ , PpssummCommon::obsid_ + " Cross-Correlation Page");
	page.body_ << hr;

	page.body_ << HtmlTag("tt","","No ACDS Cross-Correlation Products were produced.");


	page.body_ << hr;

	/* Write out the page */
	catfile << page;
	catfile.close();
	
}
