#ifndef PPSSUMM_OBS_SUMMARY
#define PPSSUMM_OBS_SUMMARY

#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <iterator>
#include "ppssumm_typedefs.h"
#include "PpssummCommon.h"
#include "HtmlTag.h"
#include "HtmlPage.h"
#include "FitsTable.h"
#include "FitsColumn.h"
#include "ExtendFitsColumn.h"
#include "ppssumm_algo.h"
#include "string_algo.h"
#include "STime.h"
#include "Dal.h"
#include "param.h"
#include "Tracer.h"
#include "errstr.h"


class ObservationSummary 
: public PpssummCommon 
{
	public:
	ObservationSummary(  DataSet* , DataSet* );
	~ObservationSummary();

	HtmlPage print();
	friend std::ostream &operator<<(std::ostream& os , ObservationSummary& sum) {

		os << sum.print();
		return os;
	}

	private:
	//DataSet* fitsum_;
	//DataSet* pidx_;

	strlist guesto_data;
	strlist proposal_data;
	strlist proposal_names;
	strlist obsrec_data;
	strlist obsrec_names;
	strtable mergedexp_table;
	
	void guesto();
	void proposal();
	void obsrec();
	void instrument();
	void exposure();

	void print_guesto(HtmlPage& );
	void print_proposal(HtmlPage&); 
	void print_obsrec(HtmlPage& );
	void print_instrument(HtmlPage& );
	void print_exposure(HtmlPage& );

};

#endif
