#ifndef PPSSUMMS_SIMPLEFUNCTIONS
#define PPSSUMMS_SIMPLEFUNCTIONS

#include <string>
#include <vector>
#include "SAttribute.h"
#include "SColumn.h"
#include "STable.h"
#include "stripws.h"

#include "Dal.h"
#include "Tracer.h"
#include "errstr.h"

/* 
 * Functions for adding SAttributes , SColumns and STables
 * to Dal DataSet's and Table's
 */

void addto(DataSet*  , const SAttribute ) ;
void addto(Table*  , const SAttribute );
void addto(Table* , const SColumn );
void addto(DataSet* , const STable );
void addto(Table* , const STable );


/*
 * Turn summary file format line into an SAttribute.
 * Line formats translate as:
 * value => SAttribute("",value,"");
 * value / comment => SAttribute("",value,comment)
 * name = value // comment => SAttribute(name,value,comment)
 * n allows an alternative key to that in the summary file, many of which are > 8 char long
 */
SAttribute MakeAttribute(std::string = "" , std::string  = "");

#endif
