#ifndef PPSSUMMSTRING_ALGO
#define PPSSUMMSTRING_ALGO
#include "ppssumm_typedefs.h"
#include <string>
#include <sstream>
#include <functional>
#include "Dal.h"
#include "Tracer.h"
#include "errstr.h"


std::string::size_type unifylength(strlist::iterator  , strlist::iterator , std::string::size_type =0 , const char =' ');


std::string truncTime( std::string ); 

/*
 * I know there is a toString in stingutil.h but it doesn't work
 * for bool8 or DString.  It returns ^A (true) and ^@ (false) 
 * and leaves trailing ^@ on the end of strings.
 */


/* 
 * WARNING
 * 
 * <string> with g++ 2.95.3 #define 's CP to be 32
 * Don't use it ! Especially not as a template parameter.
 * Aaaaaaaaaaaaaaaaaaaaargh!
 * 
 */


template< typename TP >
struct toString_ : unary_function< TP , std::string > 
 
{
	public:
	int prec_;
	toString_(int p_=0) : prec_(p_) {};
	std::string operator()( const TP& v_ , ... ) const 
	{
		std::stringstream s;
		if ( prec_ > 0 ) s.precision(prec_);
		s << v_;
		return s.str();
		
	}
};

template<>
struct toString_< std::string > : unary_function< std::string , std::string > 
{
	public:
	std::string operator()( const std::string& v_  , ... ) const 
	{
		// Strip trailing \0's from strings
		//return std::string("\0");
		static const char n='\0';
		return v_.substr(0,v_.find_first_of(n));
	}
};

template<>
struct toString_< bool8 > : unary_function< bool8 , std::string > 
{
	public:
	std::string True_, False_;
	toString_(char* pT = "Y" , char* pF ="N" ) : True_(pT) , False_(pF) {}
	std::string operator()( const bool8& v_  , ... ) const 
	{
		return v_ ? True_ : False_ ;
	}
};


struct notblank_
{
	public:
	std::string ignore_;
	notblank_( std::string ign = " \t\n" ) : ignore_(ign) {}
	bool operator()( const std::string s ) {

	/* Simple fn for use with stl algorithms */
		bool rtn;
		if ( s.empty() ) rtn = false;
		else if (ignore_.length()) rtn =  (s.find_first_not_of(ignore_) != std::string::npos) ;
		else rtn = true;

		return rtn;
	}
};
	
#endif
